Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -275,11 +887,959 @@
         },
     },
+    # 0x200c - int32u[3]: '0 0 0'; seen '2 1 0' for HX9V 3D-Image (in both JPG and MPO image)
+    # 0x200d - rational64u: 10/10, seen 2.5 for DSC-TX300V, 8 for DSC-HX100V/RX10
+    0x200e => { #PH (HX20V)
+        Name => 'PictureEffect',
+        Writable => 'int16u',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Toy Camera', #JR (A35)
+            2 => 'Pop Color', # (also A35/NEX-C3, ref JR)
+            3 => 'Posterization', #JR (A35)
+            4 => 'Posterization B/W', #JR (A35)
+            5 => 'Retro Photo', #JR (A35, NEX-5)
+            6 => 'Soft High Key', # (also A65V, A35/NEX-C3 call this "High-key", ref JR)
+            7 => 'Partial Color (red)', #JR (A35)
+            8 => 'Partial Color (green)', #JR (A35, NEX-5)
+            9 => 'Partial Color (blue)', #JR (A35)
+            10 => 'Partial Color (yellow)', #JR (A35, NEX-5)
+            13 => 'High Contrast Monochrome', #JR (A35)
+            16 => 'Toy Camera (normal)', # (also A65, ref JR)
+            17 => 'Toy Camera (cool)', # (RX100)
+            18 => 'Toy Camera (warm)', # (RX100)
+            19 => 'Toy Camera (green)', # (RX100)
+            20 => 'Toy Camera (magenta)', # (RX100)
+            32 => 'Soft Focus (low)', #JR (RX100)
+            33 => 'Soft Focus', #JR (A65V)
+            34 => 'Soft Focus (high)', # (RX100)
+            48 => 'Miniature (auto)', #JR (A65V/NEX-7, horizontal)
+            49 => 'Miniature (top)', # (RX100)
+            50 => 'Miniature (middle horizontal)', # (WX100/HX20V, horizontal)
+            51 => 'Miniature (bottom)', # (WX100, rotate 90 CW)
+            52 => 'Miniature (left)', # (RX100)
+            53 => 'Miniature (middle vertical)', # (RX100)
+            54 => 'Miniature (right)', # (RX100)
+            64 => 'HDR Painting (low)', # (RX100)
+            65 => 'HDR Painting', # (also A65V, ref JR)
+            66 => 'HDR Painting (high)', # (RX100)
+            80 => 'Rich-tone Monochrome', # (also A65V, ref JR)
+            97 => 'Water Color', # (HX200V)
+            98 => 'Water Color 2',
+            112 => 'Illustration (low)', # (RX100)
+            113 => 'Illustration', # (RX100)
+            114 => 'Illustration (high)', # (RX100)
+        },
+    },
+    0x200f => { #PH (RX100)
+        Name => 'SoftSkinEffect',
+        Writable => 'int32u',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'Mid',
+            3 => 'High',
+            # 0x10001 - seen (ref JR)
+            # 0x10002 - seen for landscape and portrait flash (ref JR)
+            # 0x10003 - seen (ref JR)
+            0xffffffff => 'n/a', # (A35)
+        },
+    },
+    0x2010 => [ #JR
+        # different camera models have similar content but at different offsets, appears to correlate with:
+        # 0x1206 - 0x1207 deciphered (0x1205 changes with firmware version):
+        #   ad c3 - NEX-5N
+        # 0x0192 - 0x0193 deciphered (0x0191 changes with firmware version):
+        #   91 c3 - NEX-VG20E
+        #   93 c3 - NEX-7, SLT-A65V/A77V
+        #   94 c3 - Hasselblad Lunar
+        # 0x0012 - 0x0013 deciphered (0x0011 changes with firmware version):
+        #   94 c3 - SLT-A37/A57, NEX-F3
+        #   95 d3 - DSC-WX50, WX70
+        #   98 c3 - DSC-HX200V, HX20V, HX30V, TX200V, TX300V
+        #   98 d3 - DSC-HX10V, TX66, WX100, WX150
+        #   9a c3 - DSC-RX1, RX1R
+        #   9b c3 - SLT-A99V, Hasselblad HV
+        #   9c c3 - NEX-VG30E
+        #   9d c3 - DSC-RX100, Hasselblad Stellar
+        #   9e c3 - NEX-VG900, SLT-A58
+        #   a1 d3 - DSC-TX30
+        #   a2 d3 - DSC-WX60, WX80, WX200, WX300
+        #   a3 c3 - NEX-6, DSC-HX300, HX50V
+        #   a4 c3 - NEX-3N/5R/5T, ILCE-3000/3500
+        # unknown offsets or values for DSC-TX20/TX55/WX30
+        # unknown offsets or values for DSC-HX60V/HX350/HX400V/QX10/QX30/QX100/RX10/RX100M2/RX100M3/WX220/WX350,
+        #                               ILCA-68/77M2, ILCE-5000/5100/6000/7/7M2/7R/7S/QX1, Stellar2, Lusso
+        # unknown offsets or values for DSC-HX80/HX90V/RX0/RX1RM2/RX10M2/RX10M3/RX100M4/RX100M5/WX500, ILCE-6300/6500/7RM2/7SM2, ILCA-99M2
+        # unknown offsets or values for ILCE-6100/6400/6600/7C/7M3/7RM3/7RM4/9/9M2, DSC-RX0M2/RX10M4/RX100M6/RX100M5A/RX100M7/HX99
+        # July 2020: ILCE-7SM3 doesn't write this tag anymore
+    {
+        Name => 'Tag2010a', # ad
+        Condition => '$$self{Model} =~ /^NEX-5N$/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag2010a' },
+    },{
+        Name => 'Tag2010b', # 91, 93
+        Condition => '$$self{Model} =~ /^(SLT-A(65|77)V?|NEX-(7|VG20E)|Lunar)$/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag2010b' },
+    },{
+        Name => 'Tag2010c', # 94
+        Condition => '$$self{Model} =~ /^(SLT-A(37|57)|NEX-F3)$/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag2010c' },
+    },{
+        Name => 'Tag2010d', # 95, 98
+        Condition => q{
+            $$self{Model} =~ /^(DSC-(HX10V|HX20V|HX30V|HX200V|TX66|TX200V|TX300V|WX50|WX70|WX100|WX150))$/ and
+            not $$self{Panorama}
+        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag2010d' },
+    },{
+        Name => 'Tag2010e', # 9a, 9b, 9c, 9d, 9e, a1, a2, a3, a4
+        Condition => q{
+            $$self{Model} =~ /^(SLT-A99V?|HV|SLT-A58|ILCE-(3000|3500)|NEX-(3N|5R|5T|6|VG900|VG30E)|DSC-(RX100|RX1|RX1R)|Stellar)$/ or
+            ($$self{Model} =~ /^(DSC-(HX300|HX50|HX50V|TX30|WX60|WX80|WX200|WX300))$/ and not $$self{Panorama})
+        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag2010e' },
+    },{
+        Name => 'Tag2010f', # ?
+        Condition => '$$self{Model} =~ /^(DSC-(RX100M2|QX10|QX100))$/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag2010f' },
+    },{
+        Name => 'Tag2010g', # ?
+        Condition => '$$self{Model} =~ /^(DSC-(QX30|RX10|RX100M3|HX60V|HX350|HX400V|WX220|WX350)|ILCE-(7(R|S|M2)?|[56]000|5100|QX1)|ILCA-(68|77M2))\b/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag2010g' },
+    },{
+        Name => 'Tag2010h', # ?
+        Condition => '$$self{Model} =~ /^(DSC-(RX0|RX1RM2|RX10M2|RX10M3|RX100M4|RX100M5|HX80|HX90V?|WX500)|ILCE-(6300|6500|7RM2|7SM2)|ILCA-99M2)\b/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag2010h' },
+    },{
+        Name => 'Tag2010i', # ?
+        Condition => '$$self{Model} =~ /^(ILCE-(6100|6400|6600|7C|7M3|7RM3|7RM4|9|9M2)|DSC-(RX10M4|RX100M6|RX100M5A|RX100M7|HX99|RX0M2)|ZV-1)\b/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag2010i' },
+    },{
+        Name => 'Tag_0x2010',
+        %unknownCipherData,
+    }],
+    0x2011 => { #PH (A77, NEX-5N)
+        Name => 'VignettingCorrection',
+        Writable => 'int32u',
+        PrintConv => {
+            0 => 'Off',
+            2 => 'Auto',
+            0xffffffff => 'n/a', # (RX100)
+        },
+    },
+    0x2012 => { #PH (A77, NEX-5N)
+        Name => 'LateralChromaticAberration',
+        Writable => 'int32u',
+        PrintConv => {
+            0 => 'Off',
+            2 => 'Auto',
+            0xffffffff => 'n/a', # (RX100)
+        },
+    },
+    0x2013 => { #PH (A77, NEX-5N) ("Setting"; application of such correction is indicated in Tag9405 - ref JR)
+        Name => 'DistortionCorrectionSetting',
+        Writable => 'int32u',
+        PrintConv => {
+            0 => 'Off',
+            2 => 'Auto',
+            0xffffffff => 'n/a', # (RX100)
+        },
+    },
+    0x2014 => { #JR/9
+        Name => 'WBShiftAB_GM',
+        Writable => 'int32s',
+        Count => 2,
+        Notes => q{
+            2 numbers: 1. positive is a shift toward amber, 2. positive is a shift
+            toward magenta
+        },
+    },
+    # 0x2015 - int16u: 65535, also for 'normal' HDR images; 0 for HDR-paint and Rich-tone Monochrome effect images
+    0x2016 => { #PH (RX100)
+        Name => 'AutoPortraitFramed',
+        Writable => 'int16u',
+        Notes => '"Yes" if this image was created by the Auto Portrait Framing feature',
+        PrintConv => { 0 => 'No', 1 => 'Yes' },
+    },
+    # 0x2017 - int32u: flash mode. 0=off, 1=fired, 2=red-eye (PH, NEX-6) (also in A99, RX1, NEX-5R)
+    0x2017 => { #JR
+        Name => 'FlashAction',
+        Writable => 'int32u',
+        PrintConv => {
+            0 => 'Did not fire',
+            1 => 'Flash Fired',
+            2 => 'External Flash Fired',
+            3 => 'Wireless Controlled Flash Fired', # (NC) seen for ILCE-9 and ILCE-7M3 images
+            # 5 => 'External Flash ???', # seen for ILCE-7RM4
+        },
+    },
+    # 0x2018 - something with external flash: seen 1 only when 0x2017 = 2
+    # 0x2019 - 0 or 1 (seen 1 for ILCA-77M2, ILCE-7M2/7RM2)
+    # 0x201a - 0 or 1
+    0x201a => { #JR
+        Name => 'ElectronicFrontCurtainShutter',
+        Writable => 'int32u',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+        },
+    },
+    0x201b => { #PH
+        # FocusMode for SLT/HV/ILCA and NEX/ILCE; doesn't seem to apply to DSC models (always 0)
+        #    from 2018: at least DSC-RX10M4 and RX100M6 also use this tag
+        Name => 'FocusMode',
+        Condition => '($$self{Model} !~ /^DSC-/) or ($$self{Model} =~ /^DSC-(RX10M4|RX100M6|RX100M7|RX100M5A|HX99|RX0M2)/)',
+        Writable => 'int8u',
+        Priority => 0,
+        PrintConv => {
+            0 => 'Manual',
+            2 => 'AF-S',
+            3 => 'AF-C',
+            4 => 'AF-A',
+            6 => 'DMF', # "Direct Manual Focus"
+            7 => 'AF-D', # "Depth Map Assist Continuous AF"
+        },
+    },
+    0x201c => [ #JR
+        # AFAreaModeSetting for SLT/HV/ILCA and NEX/ILCE; doesn't seem to apply to DSC models (always 0)
+        #    from 2018: at least DSC-RX10M4 and RX100M6 also use this tag
+        # all DSLR/SLT/HV         Wide  Zone Spot   Local
+        # all NEX and ILCE-3000   Multi      Center FlexibleSpot
+        # all ILCE and ILCA       Wide  Zone Center FlexibleSpot  ExpandedFlexibleSpot
+        # (actual AFAreaMode used may be different as camera can override this under certain conditions)
+        {
+            Name => 'AFAreaModeSetting',
+            Condition => '$$self{Model} =~ /^(SLT-|HV)/',
+            Notes => 'SLT models',
+            Writable => 'int8u',
+            PrintConv => {
+                0 => 'Wide',
+                4 => 'Local',
+                8 => 'Zone', #PH
+                9 => 'Spot',
+            },
+        },{
+            Name => 'AFAreaModeSetting',
+            Condition => '$$self{Model} =~ /^(NEX-|ILCE-|DSC-(RX10M4|RX100M6|RX100M7|RX100M5A|HX99|RX0M2))/',
+            Notes => 'NEX, ILCE and some DSC models',
+            RawConv => '$$self{AFAreaILCE} = $val',
+            DataMember => 'AFAreaILCE',
+            Writable => 'int8u',
+            PrintConv => {
+                0 => 'Wide', # all NEX and ILCE-3000/3500 use the name 'Multi'
+                1 => 'Center',
+                3 => 'Flexible Spot',
+                4 => 'Flexible Spot (LA-EA4)', # seen for ILCE-7RM2 with LA-EA4
+                9 => 'Center (LA-EA4)', # seen for ILCE-7RM2 with LA-EA4
+                11 => 'Zone',
+                12 => 'Expanded Flexible Spot',
+            },
+        },{
+            Name => 'AFAreaModeSetting',
+            Condition => '$$self{Model} =~ /^ILCA-/',
+            Notes => 'ILCA models',
+            RawConv => '$$self{AFAreaILCA} = $val',
+            DataMember => 'AFAreaILCA',
+            Writable => 'int8u',
+            PrintConv => {
+                0 => 'Wide',
+                4 => 'Flexible Spot',
+                8 => 'Zone',
+                9 => 'Center',
+                12 => 'Expanded Flexible Spot',
+            },
+        },
+    ],
+    0x201d => { #JR
+        # Flexible Spot position for NEX/ILCE, non-zero only when AFAreaMode='Flexible Spot'
+        #    from 2018: at least DSC-RX10M4 and RX100M6 also use this tag
+        # observed values in range (0 0) to (640 480), with center (320 240) often seen
+        # for NEX-5R/6, positions appear to be in an 11x9 grid
+        Name => 'FlexibleSpotPosition',
+        Condition => '$$self{Model} =~ /^(NEX-|ILCE-|DSC-(RX10M4|RX100M6|RX100M7|RX100M5A|HX99|RX0M2))/',
+        Writable => 'int16u',
+        Count => 2,
+        Notes => q{
+            X and Y coordinates of the AF point, valid only when AFAreaMode is Flexible
+            Spot
+        },
+    },
+    0x201e => [{ #PH (A99)
+        # Selected AF Point for SLT/HV/ILCA or ILCE with LA-EA2/EA4
+        # Selected AF Zone for NEX/ILCE/ILCA when AFAreaMode = 'Zone',
+        #      but also with Expanded Flexible Spot for ILCE-7RM2/7SM2/9 ...
+        # doesn't seem to apply to DSC models (always 0)
+        Name => 'AFPointSelected',
+        Condition => q{
+            ($$self{Model} =~ /^(SLT-|HV)/) or ($$self{Model} =~ /^ILCE-/ and
+            defined $$self{AFAreaILCE} and  $$self{AFAreaILCE} == 4)
+        },
+        Notes => 'SLT models or ILCE with LA-EA2/EA4',
+        Writable => 'int8u',
+        PrintConvColumns => 2,
+        PrintConv => {
+            0 => 'Auto', #(NC)
+            1 => 'Center',
+            2 => 'Top',
+            3 => 'Upper-right',
+            4 => 'Right',
+            5 => 'Lower-right',
+            6 => 'Bottom',
+            7 => 'Lower-left',
+            8 => 'Left',
+            9 => 'Upper-left',
+            10 => 'Far Right',
+            11 => 'Far Left',
+            12 => 'Upper-middle',
+            13 => 'Near Right',
+            14 => 'Lower-middle',
+            15 => 'Near Left',
+            16 => 'Upper Far Right',
+            17 => 'Lower Far Right',
+            18 => 'Lower Far Left',
+            19 => 'Upper Far Left',
+        },
+    },{
+        Name => 'AFPointSelected',
+        Condition => '$$self{Model} =~ /^ILCA-(68|77M2)/ and defined $$self{AFAreaILCA} and $$self{AFAreaILCA} != 8',
+        Notes => 'ILCA-68 and ILCA-77M2',
+        Writable => 'int8u',
+        ValueConv => '$val - 1', # to get the same numbers as from the BITMASK in 0x2020
+        ValueConvInv => '$val + 1',
+        PrintConvColumns => 5,
+        PrintConv => {
+            -1 => 'Auto',
+            %afPoints79,
+            39 => 'E6 (Center)', # (add " (Center)" to central point)
+        },
+    },{
+        Name => 'AFPointSelected',
+        Condition => '($$self{Model} =~ /^ILCA-99M2/ and defined $$self{AFAreaILCA} and $$self{AFAreaILCA} != 8)',
+        Notes => 'ILCA-99M2 when AFAreaModeSetting is not Zone',
+        # (appears to indicate the number of the selectable Focal Plane AF Point)
+        Writable => 'int8u',
+        PrintConvColumns => 4,
+        PrintConv => {
+            0 => 'Auto',                # seen for AFAreaModeSetting = Center, Wide
+            %afPoints99M2,              # for selected AFPoints corresponding to the 79 dedicated AF points
+            162 => 'E6 (162, Center)',  # add " (Center)" to central point
+            OTHER => sub { shift },     # pass other values straight through
+        },
+    },{
+        Name => 'AFPointSelected',
+        Condition => '($$self{Model} =~ /^ILCA-/ and defined $$self{AFAreaILCA} and $$self{AFAreaILCA} == 8)',
+        Notes => 'ILCA models when AFAreaModeSetting is set to Zone',
+        # ILCA-68 and 77M2 have 9 Zones: numbers/locations verified for ILCA-77M2
+        # ILCA-99M2 has 15 Zones in Hybrid-AF and 9 Zones in dedicated Phase AF Area, so may not be valid for ILCA-99M2...
+        Writable => 'int8u',
+        PrintConv => {
+            0 => 'n/a',
+            1 => 'Top Left Zone',
+            2 => 'Top Zone',
+            3 => 'Top Right Zone',
+            4 => 'Left Zone',
+            5 => 'Center Zone',
+            6 => 'Right Zone',
+            7 => 'Bottom Left Zone',
+            8 => 'Bottom Zone',
+            9 => 'Bottom Right Zone',
+          #14 => ' ??? ', # seen for ILCA-99M2
+        },
+    },{
+        Name => 'AFPointSelected',
+        # non-zero only when AFAreaMode is 'Zone', and 'Expanded-Flexible-Spot' for ILCE-6300/7RM2/7SM2
+        # each Zone has 3x3 AF Areas --> 9 positions within 5x5 total Contrast AF Areas
+        Condition => '$$self{Model} =~ /^(NEX-|ILCE-)/',
+        Notes => 'NEX and ILCE models',
+        Writable => 'int8u',
+        PrintConv => {
+            0 => 'n/a',
+            1 => 'Center Zone',
+            2 => 'Top Zone',
+            3 => 'Right Zone',
+            4 => 'Left Zone',
+            5 => 'Bottom Zone',
+            6 => 'Bottom Right Zone',
+            7 => 'Bottom Left Zone',
+            8 => 'Top Left Zone',
+            9 => 'Top Right Zone',
+        },
+    }],
+    # 0x201f - 0 0 0 0 for SLT and DSC; 4 values for NEX/ILCE with 4th value always 0:
+    # possibly bits relating to the 25 AF-Contrast-areas ???
+    # 0x2020 - 10 values; for SLT/ILCA and NEX/ILCE with A-mount lens: relates to (phase-detect) AFPoints
+    #          but not used by ILCA-99M2 anymore ... ?
+    0x2020 => [{
+        Name => 'AFPointsUsed',
+        Condition => '$$self{Model} !~ /^(ILCA-|DSC-)/', # (doesn't seem to apply to DSC-models)
+        Notes => 'SLT models, or NEX/ILCE with A-mount lenses',
+        BitsPerWord => 8,
+        BitsTotal => 80,
+        PrintConvColumns => 2,
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => {
+                0 => 'Center',
+                1 => 'Top',
+                2 => 'Upper-right',
+                3 => 'Right',
+                4 => 'Lower-right',
+                5 => 'Bottom',
+                6 => 'Lower-left',
+                7 => 'Left',
+                8 => 'Upper-left',
+                9 => 'Far Right',
+                10 => 'Far Left',
+                11 => 'Upper-middle',
+                12 => 'Near Right',
+                13 => 'Lower-middle',
+                14 => 'Near Left',
+                15 => 'Upper Far Right',
+                16 => 'Lower Far Right',
+                17 => 'Lower Far Left',
+                18 => 'Upper Far Left',
+            },
+        },
+    },{
+        Name => 'AFPointsUsed',
+        Condition => '$$self{Model} =~ /^ILCA-(68|77M2)/',
+        Notes => 'ILCA models',
+        BitsPerWord => 8,
+        BitsTotal => 80,
+        PrintConvColumns => 4,
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => { %afPoints79 },
+        },
+    }],
+    # 0x2021 - 0 for DSC; 0, 1 or 2 for SLT/ILCA and NEX/ILCE: 1=Face, 2=object-tracking ?
+    #    from 2018: at least DSC-RX10M4 and RX100M6 also use this tag
+    0x2021 => { #JR
+        Name => 'AFTracking',
+        Condition => '($$self{Model} !~ /^DSC-/) or ($$self{Model} =~ /^DSC-(RX10M4|RX100M6|RX100M7|RX100M5A|HX99|RX0M2)/)',
+        Writable => 'int8u',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Face tracking',
+            2 => 'Lock On AF',
+        },
+    },
+    # 0x2022 - 13 bytes (104 bits) for SLT-A58/A99V, NEX-3N/5R/5T/6/VG30E/VG900, ILCE-3000/3500/5000/7/7R
+    #          26 bytes (208 bits) for ILCA-77M2, ILCE-5100/6000/7M2/7S/QX1 (7M2 has 117, 5100/6000 have 179 PhaseAFPoints)
+    #          52 bytes (416 bits) for ILCE-7RM2 (which has 399 PhaseAFPoints) and ILCE-7SM2
+    #          Only seen non-zero values for ILCE-5100/6000/7M2/7RM2 in AF-C mode: maybe FocalPlaneAFPointsUsed ???
+    #          (Similar number of bytes for contemporary DSC models, but mostly all non-zero values.)
+    #          ILCE-6300 does not write this tag anymore, but writes 0x202a ...
+    0x2022 => [{
+        Name => 'FocalPlaneAFPointsUsed',
+        Condition => '$$self{Model} =~ /^(ILCE-(5100|6000|7M2))/',
+        Notes => 'On-sensor/focal-plane phase AF points for ILCE with hybrid AF',
+        BitsPerWord => 8,
+        BitsTotal => 208, # 26 words
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => { },
+        },
+    },{
+        Name => 'FocalPlaneAFPointsUsed',
+        Condition => '$$self{Model} =~ /^ILCE-7RM2/',
+        # ILCE-7RM2 has 399 points in 19 rows of 21 points, numbered [0] to [398], [199] is Center
+        BitsPerWord => 8,
+        BitsTotal => 416, # 52 words
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => { },
+        },
+    }],
+    0x2023 => { #JR
+        Name => 'MultiFrameNREffect',
+        Writable => 'int32u',
+        PrintConv => {
+            0 => 'Normal',
+            1 => 'High', # seen this only for ILCA-77M2 MFNR-12 images
+        },
+    },
+    # 0x2024 - 96 byte data block, very similar to 0x3000 ShotInfo, seen in Xperia Z5
+    # 0x2025 - n1 n2 0 0         DSC-RX100M3/RX100M4/RX10M2/HX90V/WX500, ILCA-77M2, ILCE-5100/7M2/7RM2/7S/QX1
+    #          seen n1=0,2,4,5,7 and n2=0,1,3, very often: 7 3 0 0
+
+    # 0x2026 - 2 values: more precise WB Shift: AB in steps of 0.50, GM in steps of 0.25 (ILCE-7RM2 onwards)
+    0x2026 => { #JR
+        Name => 'WBShiftAB_GM_Precise',
+        Writable => 'int32s',
+        Count => 2,
+        Notes => q{
+            2 numbers: 1. positive is a shift toward amber, 2. positive is a shift
+            toward magenta
+        },
+        PrintConv => 'my @v=split(" ",$val); $_/=1000 foreach @v; sprintf("%.2f %.2f",$v[0],$v[1])',
+    },
+    # 0x2027 - W H W/2 H/2  or  W H val1 val2  (0 0 0 0 for Panorama images)
+    #          Probably location of focus for Playback Zoom.
+    #          Origin appears to be top-left, i.e. 1st coord to the right, 2nd coord. pointing down.
+    0x2027 => { #JR
+        Name => 'FocusLocation', #(NC)
+        Writable => 'int16u',
+        Count => 4,
+        NOTES => q{
+            Location in the image where the camera focused, used for Playback Zoom.
+            If the focus location information cannot be obtained, the centre of the
+            image will be used.
+        },
+    },
+    # 0x2028 - 0 0 for DSC-RX100M4/RX10M2, ILCE-7RM2/7SM2; seen non-zero values only for DSC-RX1RM2
+    0x2028 => { #JR
+        Name => 'VariableLowPassFilter',
+        Writable => 'int16u',
+        Count => 2,
+        PrintConv => {
+            '0 0' => 'n/a',
+            '1 0' => 'Off',
+            '1 1' => 'Standard',
+            '1 2' => 'High',
+            '65535 65535' => 'n/a', # ILCE-7SM3
+        },
+    },
+    0x2029 => { # uncompressed 14-bit RAW file type setting introduced 2015
+        Name => 'RAWFileType',
+        Writable => 'int16u',
+        PrintConv => {
+            0 => 'Compressed RAW',
+            1 => 'Uncompressed RAW',
+            2 => 'Lossless Compressed RAW', #JR (NC) seen for ILCE-1
+           65535 => 'n/a', # seen for ILCE-7SM3 JPEG-only
+        },
+    },
+    # 0x202a - first seen for ILCE-6300: 66 bytes
+    #          possibly a 'replacement' for Tag2022 FocalPlaneAFPointsUsed,
+    #          but now indicating locations in a 640x428 grid (3:2 part of LCD ?)
+    # first byte value 1 for ILCE-6300/6500/9, ILCA-99M2
+    #            values 110,137, ... for DSC-RX10M3, therefore limit to first byte = 1 for now
+    0x202a => {
+        Name => 'Tag202a',
+        Condition => '$$valPt =~ /^\x01/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag202a' },
+    },
+    0x202b => { #JR (ILCA-99M2, ILCE-6500/7M3/7RM3/9, DSC-RX10M4/RX100M5 and newer)
+        Name => 'PrioritySetInAWB',
+        Writable => 'int8u',
+        PrintConv => {
+            0 => 'Standard',
+            1 => 'Ambience',
+            2 => 'White',
+        },
+    },
+    0x202c => { #JR
+        Name => 'MeteringMode2',
+        Writable => 'int16u',
+        PrintHex => 1,
+        PrintConv => {
+            0x100 => 'Multi-segment',
+            0x200 => 'Center-weighted average',
+            0x301 => 'Spot (Standard)',
+            0x302 => 'Spot (Large)',
+            0x400 => 'Average',
+            0x500 => 'Highlight',
+        },
+    },
+    0x202d => { #JR first seen for ILCA-99M2, ILCE-6500, DSC-RX100M5
+        Name => 'ExposureStandardAdjustment',
+        Writable => 'rational64s',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => '$val',
+    },
+    0x202e => { #JR (ILCE-7M3/7RM3 and newer)
+        Name => 'Quality',
+        Writable => 'int16u',
+        Count => 2,
+        PrintConv => {
+            '0 0' => 'n/a',
+            '0 1' => 'Standard JPEG',
+            '0 2' => 'Fine JPEG',
+            '0 3' => 'Extra Fine JPEG',
+            '1 0' => 'RAW',
+            '1 1' => 'RAW + Standard JPEG',
+            '1 2' => 'RAW + Fine JPEG',
+            '1 3' => 'RAW + Extra Fine JPEG',
+        },
+    },
+    0x202f => { #JR (ILCE-7RM3)
+        Name => 'PixelShiftInfo',
+        Writable => 'undef',
+        # 6 bytes, all 0 for non-PixelShift images
+        # first 4 bytes: GroupID, read as int32u
+        #    the ID displayed by Sony ImageDataConverter appears to be based on the lower 22 bits:
+        #    5 bits, 5 bits, 6 bits, 6 bits
+        # last 2 bytes: ShotNumber: (1 4) to (4 4) and (1 16) to (16 16) are the 4 or 16 source images,
+        #                           (0 4) is the combined image for 4-shot PixelShift mode
+        #                           (0 16) is the combined image for 16-shot PixelShift mode (ILCE-7RM4)
+        RawConv => q{
+            my ($a,$b,$c) = (Get32u(\$val,0), Get8u(\$val,4), Get8u(\$val,5));
+            sprintf("%.2d%.2d%.2d%.2d %d %d 0x%x",($a>>17)&0x1f,($a>>12)&0x1f,($a>>6)&0x3f,$a&0x3f,$b,$c,$a>>22);
+        },
+        RawConvInv => q{
+            my ($a,$b,$c,$d) = split ' ', $val;
+            my @a = $a =~ /../g;
+            return undef unless @a == 4;
+            return Set32u((hex($d)<<22) | ($a[0]<<17) | ($a[1]<<12) | ($a[2]<<6) | $a[3]) . chr($b) . chr($c);
+        },
+        PrintConv => {
+            '00000000 0 0 0x0' => 'n/a',
+            OTHER => sub {
+                my ($val, $inv) = @_;
+                if ($inv) {
+                    $val =~ s{Composed (\d+)-shot}{Shot 0/$1}i;
+                    $val =~ s{^(?:Group)?\s*(\d+)[, ]+(?:Shot\s*)?(\d+)[/ ](\d+)\s*\(?(\w+)\)?}{$1 $2 $3 $4}i or return undef;
+                } else {
+                    $val =~ s{(\d+) (\d+) (\d+) (\w+)}{Group $1, Shot $2/$3 ($4)} or return undef;
+                    $val =~ s{Shot 0+/0*(\d+)\b}{Composed $1-shot}i;
+                }
+                return $val;
+            },
+        },
+    },
+    0x2031 => { #JR (only for ILCE-9 v2.00; ILCE-9 v2.10 and higher have "option" to write into EXIF tag 0xa431 )
+        Name => 'SerialNumber',
+        Writable => 'string',
+        ValueConv => '$val=~s/(\d{2})(\d{2})(\d{2})(\d{2})/$4$3$2$1/; $val=~s/^0//; $val',
+        ValueConvInv => '$val="0$val" if length($val)==7; $val=~s/(\d{2})(\d{2})(\d{2})(\d{2})/$4$3$2$1/; $val',
+        PrintConv => 'sprintf("%.8d",$val)',
+        PrintConvInv => '$val',
+    },
+# 0x2032 - first seen for ILCE-7SM3, July 2020
+# 0x2033 - first seen for ILCE-7SM3, July 2020
+# 0x2034 - first seen for ILCE-7SM3, July 2020
+# 0x2035 - first seen for ILCE-7SM3, July 2020
+# 0x2036 - first seen for ILCE-7SM3, July 2020
+# 0x2037 - first seen for ILCE-7SM3, July 2020
+# 0x2039 - first seen for ILCE-7SM3, July 2020
     0x3000 => {
         Name => 'ShotInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::ShotInfo' },
+    },
+    # 0x3000: data block that includes DateTimeOriginal string
+    # 0x5001 - 0
+    # 0x5002 - 128
+#
+# at least some data for tags 0x2010, 0x9050 and 0x94xx is encrypted - PH
+# (This is certainly true for at least parts of 0x2010, 0x9050, 0x9400, 0x9402 and 0x9403,
+# but hasn't been verified for other tags -- just to be thorough, decipher all of them)
+# Note: "(e)" in a comment indicates an enciphered value, all other values are deciphered
+#
+    # 0x900b - 1st byte 0xae: face detection info for A450/500/550/560/580, A33/35/55, NEX-3/5/5C/C3/VG10
+    #        - other 1st byte values for some DSC-models
+    #        - seen many 1,8,27,64... values: assume encrypted like other 9xxx tags
+    0x900b => {
+        Name => 'Tag900b',
+        Condition => '$$valPt =~ /^\xae/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag900b' },
+    },
+    0x9050 => [
+    # 944 bytes for A37, A57, A99, NEX-F3, NEX-5R, NEX-6, DSC-RX1, DSC-RX100
+    # 3072 bytes for A65, A77, NEX-5N, NEX-7, NEX-VG20 (ref JR)
+    # not valid for DSC/Stellar models
+    # from mid-2015: ILCE-7RM2/7SM2/6300 and newer models use different offsets
+    {
+        Name => 'Tag9050a',
+        Condition => '$$self{Model} !~ /^(DSC-|Stellar|ILCE-(1|6100|6300|6400|6500|6600|7C|7M3|7RM2|7RM3|7RM4|7SM2|7SM3|9|9M2)|ILCA-99M2|ZV-)/',
         SubDirectory => {
-            TagTable => 'Image::ExifTool::Sony::ShotInfo',
-        },
-    },
-    # 0x3000: data block that includes DateTimeOriginal string
+            TagTable => 'Image::ExifTool::Sony::Tag9050a',
+            ByteOrder => 'LittleEndian',
+        },
+    },{
+        Name => 'Tag9050b',
+        Condition => '$$self{Model} =~ /^(ILCE-(6100|6300|6400|6500|6600|7C|7M3|7RM2|7RM3|7RM4|7SM2|9|9M2)|ILCA-99M2)/',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Sony::Tag9050b',
+            ByteOrder => 'LittleEndian',
+        },
+    },{
+        Name => 'Tag9050c',
+        Condition => '$$self{Model} =~ /^(ILCE-(1|7SM3))/',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Sony::Tag9050c',
+            ByteOrder => 'LittleEndian',
+        },
+    },{
+        Name => 'Sony_0x9050',
+        %unknownCipherData,
+    }],
+    0x9400 => [
+    # first byte:
+    # 0x07 (e) for DSC-HX7V/HX9V/HX100V/TX10/TX100/TX100V/WX7/WX9/WX10, HDR-CX../PJ..
+    # 0x09 (e) for DSC-TX20/TX55/WX30
+    # 0x0a (e) for SLT-A37/A57/A65V/A77V/A99V, NEX-F3/5N/5R/5T/6/7/VG20E, DSC-RX100/RX1/RX1R/HX10V/HX20V/HX30V/HX200V/TX200V/TX300V/TX66/WX50/WX100/WX150, Lunar/Stellar/HV
+    # 0x0c (e) for ILCE-3000/3500, NEX-3N, SLT-A58, DSC-HX50V/HX300/RX100M2/TX30/WX60/WX80/WX200/WX300, DSC-QX10/QX100
+    # 0xd0 (e) H90, W650, W690: tag9400 decoding appears not valid/different
+    # 0x23 (e) for DSC-RX10/HX60V/HX350/HX400V/WX220/WX350, ILCE-7/7R/5000/6000, ILCA-68/77M2
+    # 0x24 (e) for ILCA-99M2,ILCE-5100/6300/6500/7M2/7RM2/7S/7SM2/QX1, DSC-HX80/HX90V/QX30/RX0/RX100M3/RX100M4/RX100M5/RX10M2/RX10M3/RX1RM2/WX500
+    # 0x26 (e) for ILCE-6100/6400/6600/7M3/7RM3/9, DSC-RX0M2/RX10M4/RX100M5A/RX100M6/HX99
+    # 0x28 (e) for ILCE-7RM4/9M2, DSC-RX100M7, ZV-1
+    # 0x31 (e) for ILCE-1, 7SM3
+    # first byte decoded: 40, 204, 202, 27, 58, 62, 48, 215, 28, 106 respectively
+    {
+        Name => 'Tag9400a',
+        Condition => q{
+            $$valPt =~ /^[\x07\x09\x0a]/ or
+           ($$valPt =~ /^[\x5e\xe7\x04]/ and $$self{DoubleCipher} = 1)
+        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9400a' },
+    },{
+        Name => 'Tag9400b',
+        Condition => '$$valPt =~ /^\x0c/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9400b' },
+    },{
+        Name => 'Tag9400c',
+        Condition => '$$valPt =~ /^[\x23\x24\x26\x28\x31]/', 
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9400c' },
+    },{
+        Name => 'Sony_0x9400',
+        %unknownCipherData,
+    }],
+    0x9401 => {
+        Name => 'Tag9401',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9401' },
+        # notes for data in this block (ref PH/JR):
+        #   0x02-0x03 appear to have some relation to start-offset of data...
+        #   0x00 - 0x03    Metering
+        #                  Mode
+        #   f4 00 00 03      -        -   DSC-H90/W650/W690
+        #   cf 0b 9f 0f    0x09bc    (a)  DSC-WX9
+        #   1c 00 ac 0f    0x09c9    (b)  HDR-CX130E/CX160E/CX360E/CX560E/CX700E/PJ10E/PJ30E
+        #   b7 0f f7 0f    0x09dd    (c)  DSC-HX7V/TX10/WX7/WX10
+        #   b7 0f fa 0f    0x09e0    (d)  DSC-HX9V/HX100V/TX100/TX100V
+        #   27 00 fd 0f    0x09e7    (e)  DSC-TX20/TX55/WX30
+        #   69 1f ff 0f    0x09e9    (f)  NEX-5N
+        #   21 2b cf 0f    0x09e9    (f)  NEX-7/VG20E, SLT-A65V/A77V, Lunar
+        #   2d 00 d5 0d    0x09a2    (g)  DSC-HX10V/HX20V/HX30V/HX200V/TX66/TX200V/TX300V/WX50/WX70/WX100/WX150
+        #   2f 00 d6 0d    0x09a3    (h)  NEX-F3, SLT-A37/A57
+        #   30 00 d8 0d    0x09a5    (i)  HDR-AS15
+        #   32 00 e2 0d    0x09ac    (j)  DSC-RX100, Stellar
+        #   33 00 e2 0d    0x09ac    (j)  NEX-5R/5T/6, NEX-VG900/VG30E
+        #   33 50 e2 0d    0x09ac    (j)  SLT-A99V, HV
+        #   33 40 0d 0e    0x09d7    (k)  DSC-RX1 v0.01
+        #   33 41 0d 0e    0x09d7    (k)  DSC-RX1, DSC-RX1R
+        #   38 00 32 0e    0x09fc    (l)  SLT-A58, ILCE-3000/3500, NEX-3N, DSC-HX300/HX50V/WX200/WX300/WX60/WX80/TX30
+        #   3a 10 3a 0e    0x0a01    (m)  DSC-QX10/QX100
+        #   3a 20 47 0e    0x0a01    (m)  DSC-RX100M2
+        #   43 00 66 0e    0x0a1b    (n)  ILCE-7/7R v0.xx/v1.00/v1.01, ILCE-5000, DSC-RX10
+        #   43 10 66 0e    0x0a1b    (n)  ILCE-7/7R v1.02/v1.10
+        #   43 30 6c 0e    0x0a1b    (n)  ILCE-7/7R v1.20-v3.20
+        #   44 00 9c 0e    0x0a39    (o)  ILCE-6000 v1.00/v1.10, DSC-HX60V/HX350/HX400V/WX220/WX350 (also DSC-QX30 samples from sony.net)
+        #   44 10 a2 0e    0x0a39    (o)  ILCE-6000 v1.20/v1.21
+        #   44 20 a2 0e    0x0a39    (o)  ILCE-6000 v2.00-v3.20
+        #   49 00 b0 0e    0x0a3b    (p)  ILCA-68 v1.00, ILCA-77M2 V1.00/v1.01/v2.00 (also DSC-RX100M3 samples from sony.net)
+        #   4a 00 b3 0e    0x0a3d    (q)  ILCE-7S v1.00, ILCE-5100 v1.00/v1.10, ILCE-QX1, DSC-QX30/RX100M3
+        #   4a 20 b9 0e    0x0a3d    (q)  ILCE-7S v1.20-v3.20
+        #   4e 10 d0 0e    0x0a5a    (r)  ILCE-7M2 v1.00/v1.10
+        #   4e 30 d6 0e    0x0a5a    (r)  ILCE-7M2 v1.20-v4.00
+        #   5a 00 14 0f    0x0a85    (s)  DSC-HX80/HX90V/WX500
+        #   5d 00 56 0f    0x0ac7    (t)  DSC-RX10M2/RX100M4, ILCE-7RM2/7SM2 v1.00-v2.20 (also DSC-RX1RM2 samples from Sony)
+        #   5d 1d 58 0f    0x0ac7    (t)  ILCE-7RM2 v3.00-v4.00
+        #   5d 1e 57 0f    0x0ac7    (t)  DSC-RX1RM2 v1.00
+        #   5d 10 56 0f    0x0ac7    (t)  ILCE-6300 v1.00 (samples from Sony)
+        #   5d 20 58 0f    0x0ac7    (t)  ILCE-6300 v1.00/v1.10
+        #   5e 00 56 0f    0x0ac7    (t)  DSC-RX10M3 v1.00
+        #   64 00 a8 0f    0x0b15    (u)  DSC-RX100M5 v1.00
+        #   67 00 f9 0f    0x0b66    (v)  ILCA-99M2 v1.00, ILCE-6500 v1.00-v1.05, DSC-RX0 v1.00
+        #   7c 00 fe 0f    0x0adb    (w)  ILCE-9 v0.01-v2.00
+        #   7d 00 fe 0f    0x0adb    (w)  ILCE-9 v2.10-v4.10
+        #   7f 00 fa 0f    0x0add    (x)  DSC-RX10M4 v1.00
+        #   80 00 fa 0f    0x0add    (x)  ILCE-7M3/7RM3 v1.00-v3.01
+        #   82 00 fc 0f    0x0ad9    (y)  DSC-RX100M5A v1.00, DSC-RX100M6 v1.00
+        #   90 00 fe 0f    0x098f?   (z)  DSC-HX99 v1.00
+        #   92 10 ff 0f    0x0990    (za) ILCE-6100/6400/6600 v1.00
+        #   94 00 ce 0b    0x0879    (zb) ILCE-9 v5.00-v6.00, DSC-RX0M2
+        #   98 00 db 0c    0x088a    (zc) ILCE-7RM4 v1.00
+        #   9a 00 e3 0c    0x088a    (zc) DSC-RX100M7 v1.00, ILCE-9M2 v1.00
+        #
+        # 0x0004 - (RX100: 0 or 1. subsequent data valid only if 1 - PH)
+        # 0x0007 => {
+        #     Name => 'DynamicRangeOptimizer_9401',
+        #     PrintConv => {
+        #         0 => 'Disabled', # seen for Panorama images
+        #         1 => 'Auto',
+        #         3 => 'Lv1', #(NC)
+        #         4 => 'Lv2', #(NC)
+        #         5 => 'Lv3',
+        #         6 => 'Lv4',
+        #         7 => 'Lv5',
+        #         # 8 - seen for VG20E and some other models - PH
+        #         255 => 'Off',
+        #     },
+        # },
+    },
+    0x9402 => [{
+        Name => 'Tag9402',
+        # first 2 bytes deciphered:
+        #   0x00      0x00     SLT-A37/A57/A65/A77
+        #   0x0e      0x00     DSC-H90/HX7V/HX9V/HX100V/TX10/TX100/TX100V/TX20/TX55/W650/W690/W730/WX10/WX30/WX7/WX9, but also seen:
+        #     0x0e      0x01     for a few DSC-W650/W690 samples ...
+        #   0x0f      0x01     NEX-5N/7/VG20, Lunar
+        #   0x10      0x01     DSC-HX10V/HX200V/HX20V/HX300/HX30V/HX50V/TX200V/TX30/TX300V/TX66/RX100/RX1/RX1R/WX100/WX150/WX200/WX300/WX50/WX60/WX70/WX80, Stellar,
+        #                      ILCE-3000/3500, NEX-F3/3N/5R/5T/6/VG30/VG900
+        #   0x11      0x01     DSC-RX100M2/QX10/QX100
+        #   0x13      0x01     ILCE-5000/7/7R, DSC-RX10, but also seen:
+        #     0x12      0x01     for ILCE-7/7R and DSC-RX10 samples from Sony.net ...
+        #     0x15      0x01     for a few ILCE-7/7R ...
+        #   0x14      0x01     ILCE-6000, DSC-HX60V/HX350/HX400V/WX220/WX350
+        #   0x17      0x01     ILCE-7S/7M2/5100/QX1, DSC-QX30/RX100M3
+        #   0x19      0x01     DSC-HX80/HX90V/RX1RM2/RX10M2/RX100M4/WX500, ILCE-6300/7RM2/7SM2
+        #   0x1a      0x01     DSC-RX0/RX10M3/RX100M5, ILCE-6500
+        #   0x1c      0x01     ILCE-9
+        #   0x1d      0x01     DSC-RX10M4
+        #   0x1e      0x01     ILCE-7M3/7RM3, DSC-RX100M5A/RX100M6
+        #   0x1f      0x01     DSC-HX99
+        #   0x20      0x01     ILCE-6100/6400/6600/7RM4/9M2, ILCE-9 v5.00-v6.00, DSC-RX0M2/RX100M7
+        #   var       var      SLT-A58/A99V, HV, ILCA-68/77M2/99M2
+        # only valid when first byte 0x0f, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x17, 0x19, 0x1a, 0x1c (enciphered 0x8a, 0x70, 0xb6, 0x69, 0x88, 0x20, 0x30, 0xd7, 0xbb, 0x92, 0x28)
+#        Condition => '$$self{DoubleCipher} ? $$valPt =~ /^[\x7e\x46\x1d\x18\x3a\x95\x24\x26\xd6]\x01/ : $$valPt =~ /^[\x8a\x70\xb6\x69\x88\x20\x30\xd7\xbb\x92\x28]\x01/',
+# alternative simpler Condition:
+# not valid for SLT/HV/ILCA models, and not valid for first byte 0x0e or 0xff (enciphered 0x05 or 0xff)
+        Condition => '$$self{Model} !~ /^(SLT-|HV|ILCA-)/ and $$valPt !~ /^[\x05\xff]/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9402' },
+    },{
+        Name => 'Sony_0x9402',
+        %unknownCipherData,
+    }],
+    0x9403 => {
+        Name => 'Tag9403',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9403' },
+    },
+    # 0x9404 first 5 bytes (deciphered):
+    #  4  0  163  1  2     SLT-A65V/A77V, NEX-5N/7, Lunar, DSC-HX7V/HX9V/HX100V/TX10/TX20/TX55/TX100/TX100V/WX9/WX10/WX30...
+    #  5  0  172  1  2     DSC-HX10V/HX200V/HX20V/HX30V/TX66/TX200V/TX300V/WX50/WX70/WX100/WX150...
+    #  9  0   38  2  2     SLT-A37/A57/A99V, NEX-5R/5T/6/F3/VG30E/VG900, DSC-RX1/RX1R/RX100, Stellar
+    # 12  0    8  2  2     SLT-A58, NEX-3N, ILCE-3000/3500, DSC-HX300/HX50V/WX60/WX80/WX300/TX30...
+    # 13  0    9  2  2     DSC-QX10/QX100/RX100M2
+    # 15  0   35  2  2     ILCA-68/77M2, ILCE-5000/5100/6000/7/7R/7S/7M2/QX1, DSC-HX60V/HX350/HX400V/QX30/RX10/RX100M3/WX220/WX350
+    # 16  0   85  2  2     DSC-HX80/HX90V/WX500
+    # 17  0  232  1  2     DSC-RX0/RX0M2/RX1RM2/RX10M2/RX10M3/RX10M4/RX100M4/RX100M5/RX100M5A/RX100M6/RX100M7/HX99, ILCE-6100/6300/6400/6500/6600/7C/7M3/7RM2/7RM3/7RM4/7SM2/9/9M2, ILCA-99M2, ZV-1
+    # 18  0   20  0 164    ILCE-7SM3 
+    # other values for Panorama images and several other models
+    0x9404 => [{
+        Name => 'Tag9404a',
+        # first byte must be 4 or 5 and 4th byte must be 1 (deciphered)
+        Condition => '$$valPt =~ /^[\x40\x7d]..\x01/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9404a' },
+    },{
+        Name => 'Tag9404b',
+        # first byte must be 9 or 12 or 13 or 15 or 16 and 4th byte must be 2 (deciphered)
+        Condition => '$$valPt =~ /^[\xe7\xea\xcd\x8a\x70]..\x08/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9404b' },
+    },{
+        Name => 'Tag9404c',
+        # first byte must be 17 and 4th byte must be 1 (deciphered)
+        Condition => '$$valPt =~ /^\xb6..\x01/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9404c' },
+    },{
+        Name => 'Sony_0x9404',
+        %unknownCipherData,
+    }],
+    # 0x9405 first 2 bytes:
+    #   0   0  (0x00 =   0   0 enc.) DSC-H90
+    #   2   0  (0x08 =   8   0 enc.) DSC and HDR of HX9V generation
+    #   3   0  (0x1b =  27   0 enc.) SLT, NEX, ILCE-3000/3500, DSC-RX100/RX1 + other DSC of same generation, also QX10 and QX100
+    #   4   0  (0x40 =  64   0 enc.) DSC-RX1R
+    #   5   0  (0x7d = 125   0 enc.) DSC-RX100M2
+    # 136 var  (0x3a =  58 var enc.) ILCE-7/7R/5000/6000, DSC-HX60V/HX350/HX400V/RX10/WX220/WX350
+    # 137 var  (0xb3 = 179 var enc.) ILCA-68/77M2, DSC-RX100M3 - appears to go with 136
+    # 138 var  (0x7e = 126 var enc.) ILCE-7S/5100/QX1, DSC-QX30   - appears to go with 136
+    # 139 var  (0x9a = 154 var enc.) ILCE-7M2
+    # 142 var  (0x25 =  37 var enc.) DSC-HX80/HX90V/RX1RM2/RX10M2/RX10M3/RX100M4/WX500, ILCE-6300/7RM2/7SM2
+    # 144 var  (0xe1 = 225 var enc.) DSC-RX100M5
+    # 145 var  (0x76 = 118 var enc.) ILCA-99M2, ILCE-6500, DSC-RX0
+    # 163 var  (0x8b = 139 var enc.) ILCE-6100/6400/6600/7C/7M3/7RM3/7RM4/9/9M2, DSC-RX0M2/RX10M4/RX100M5A/RX100M6/RX100M7/HX99, ZV-1
+    # July 2020: ILCE-7SM3 doesn't write this tag anymore, but writes 0x9416
+    0x9405 => [{
+        Name => 'Tag9405a',
+        # first byte must be 0x1b or 0x40 or 0x7d
+        Condition => '$$valPt =~ /^[\x1b\x40\x7d]/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9405a' },
+    },{
+        Name => 'Tag9405b',
+        # first byte must be 0x3a, 0xb3, 0x7e, 0x9a, 0x25, 0xe1, 0x76 or 0x8b
+        Condition => '$$valPt =~ /^[\x3a\xb3\x7e\x9a\x25\xe1\x76\x8b]/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9405b' },
+    },{
+        Name => 'Sony_0x9405',
+        %unknownCipherData,
+    }],
+    0x9406 => [{
+        Name => 'Tag9406',
+        # - first byte must be 0x01 or 0x02 (enciphered 0x01 or 0x08),
+        #   or 0x03 (enc. 0x1b) for ILCE-6100/6300/6400/6500/6600/7M3/7RM2/7RM3/7RM4/7SM2/9/9M2, and ILCA-99M2
+        #   third byte must be 0x02 or 0x03 (enciphered 0x08 or 0x1b) - ref JR
+        # (applies to most SLT/ILCA and NEX/ILCE models, but no DSC models)
+        Condition => '$$valPt =~ /^[\x01\x08\x1b].[\x08\x1b]/s',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9406' },
+    },{
+        Name => 'Sony_0x9406',
+        %unknownCipherData,
+    }],
+    0x9407 => {
+        Name => 'Sony_0x9407',
+        %unknownCipherData,
+    },
+    0x9408 => {
+        Name => 'Sony_0x9408',
+        %unknownCipherData,
+    },
+    0x9409 => {
+        Name => 'Sony_0x9409',
+        %unknownCipherData,
+    },
+    0x940a => [{
+        Name => 'Tag940a',
+        Condition => '$$self{Model} =~ /^(SLT-|HV)/', # but appears not valid for ILCA models ...
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag940a' },
+    },{
+        Name => 'Sony_0x940a',
+        %unknownCipherData,
+    }],
+    0x940b => {
+        Name => 'Sony_0x940b',
+        %unknownCipherData,
+    },
+    0x940c => [{
+        Name => 'Tag940c',
+        Condition => '$$self{Model} =~ /^(NEX-|ILCE-|Lunar)\b/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag940c' },
+    },{
+        Name => 'Sony_0x940c',
+        %unknownCipherData,
+    }],
+    0x940d => {
+        Name => 'Sony_0x940d',
+        %unknownCipherData,
+    },
+#   0x940e: 2nd byte = 0: no AFInfo, default for NEX/ILCE
+#           2nd byte = 1: AFInfo for SLT/ILCA models (but also seen 1 for DSC-HX20W/HX300/WX70 ...)
+#           2nd byte = 2: AFInfo for NEX/ILCE with LA-EA2/EA4 Phase-detect AF Adapter
+    0x940e => [{
+        Name => 'AFInfo',
+        Condition => '$$self{Model} =~ /^(SLT-|HV|ILCA-)/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::AFInfo' },
+    },{
+        Name => 'Tag940e',
+        Condition => '$$self{Model} =~ /^(NEX-|ILCE-|Lunar)/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag940e' },
+    },{
+        Name => 'Sony_0x940e',
+        %unknownCipherData,
+    }],
+    0x940f => {
+        Name => 'Sony_0x940f',
+        %unknownCipherData,
+    },
+    0x9411 => {
+        Name => 'Sony_0x9411',
+        %unknownCipherData,
+        # 0x02 - int32u?: 1,3,5,7,9 (A77)
+    },
+    0x9416 => { # replaces 0x9405 for the Sony ILCE-7SM3, from July 2020
+        Name => 'Sony_0x9416',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Tag9416' },
+    },
     0xb000 => { #8
         Name => 'FileFormat',
